
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>软件测试中的黑天鹅系列（一） 认识软件测试中的黑天鹅 / iVAN</title>

    <meta name="description" content="软件测试中的黑天鹅系列（一） 认识软件测试中的黑天鹅 1. 软件测试中的&quot;黑天鹅&quot; 几年前,我带领的一个测试小组遗漏了一个严重的bug到网上,当用户反馈这个bug后, 我们对它进行了深入的分析和重现,最终所有人一致认为,这个bug能够发生实在是机缘巧合,因为它需要多个条件同时发 生才有可能触发,比如&quot;XX算法开关必须打开.XX算法开关又必须关闭.XX参数必须取某个特定值.用户的使用环境必须是 XX个场景.硬件必须是使用XX接口板.软件必须是XX版本.XX的带宽恰巧又不够...&quot;,在用户那里,这些条件有一条不  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">软件测试中的黑天鹅系列（一） 认识软件测试中的黑天鹅</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>1. 软件测试中的“黑天鹅”</p>
<p>几年前，我带领的一个测试小组遗漏了一个严重的bug到网上，当用户反馈这个bug后，  我们对它进行了深入的分析和重现，最终所有人一致认为，这个bug能够发生实在是机缘巧合，因为它需要多个条件同时发  生才有可能触发，比如“XX算法开关必须打开、XX算法开关又必须关闭、XX参数必须取某个特定值、用户的使用环境必须是  XX个场景、硬件必须是使用XX接口板、软件必须是XX版本、XX的带宽恰巧又不够。。。”，在用户那里，这些条件有一条不  满足，就不会发生这个bug。</p>
<p>由于这个bug的影响比较严重，又是用户报告的，照例要提交缺陷根因分析报告。其中  ，报告里有一项“后续如何发现这类缺陷，确保不遗漏？”我们不知道如何避免这样的缺陷再次发生，实际上，如果从正向  设计的角度，我们无论如何也不会设计一个满足上述所有条件的用例，也不会去执行这样的测试。不过，我们不得不费尽心  思地去思考，这个bug的发生是如何有其合理性的、是可以解释的、因此也是可以预防的，以填补报告里这一项的空白。</p>
<p>前不久我阅读了一本书叫做《黑天鹅》。数千年来，人们认为世界上只有白天鹅，但是发现第一只澳大利亚黑天鹅  以后，这种牢不可破的观念被颠覆了。作者指出“黑天鹅事件”满足三个特征：</p>
<p>- 稀有性，  或意外性，即它通常在预期之外；</p>
<p>- 冲击性，即它会产生极端影响；</p>
<p>- 事后（而不是事前）可预测性，人的本性促使我们在事后为它的发生编织理由，并且或多或少地认为它是可  解释和可预测的。</p>
<p>很多重要的线上bug不就是测试中的“黑天鹅”吗？它们的发生在你的预期之外、产生了极端的影  响、事后人们总是认为这些bug是可以避免的。</p>
<p>仔细想一想，你所在的项目中是否有“黑天鹅”？2013年1月31日，  亚马逊主页瘫痪近1小时，你是否提前预期到了（《黑天鹅》书中写到，“从对称的角度讲，一个高度不可能事情的发生，  与一个高度可能事件的不发生是一样的”）？12306网站的瘫痪、高铁事故、ATM取款系统故障。。。，你是否能提前预期到  ？其实，你可能已经发现，“黑天鹅”离我们并不遥远，总是有那么多被认为不应该发生的现象实际发生了。</p>
<p>造成  “黑天鹅”现象的可能有很多种原因，从测试的角度讲，我们如何来认识软件测试中的“黑天鹅” – 那些总是让人意想不  到又产生严重后果的bug呢？</p>
<p>2. 对“黑天鹅”视而不见</p>
<p>人们习 惯于对“黑天鹅”视而不见。“社会学家一  直错误地以为他们的理论能够衡量不确定的事物”。人们相信通过使用趋势分析工具和复杂的数学公式可以帮助我们很好地  预测股票市场的风险、挑选一支好的股票，结果大失所望的人不在少数；人们相信复杂的科学仪器和先进的数学、物理学、  天文学等理论可以帮助我们很好地预测地震、海啸、天气，结果经常有令人意想不到的自然灾害发生。</p>
<p>人们习惯于  使用确定性的理论去推测那些不确定的事物，在这个处处都充满了“变数”的时代，“以不变应万变”的做法已不合适。  RBT(基于风险的测试)是个不错的方法，有些人会按照既定的套路使用RBT：在项目的某个时间点，邀请相关人一起收集风险  、分析风险，然后按照风险分析结果开展测试活动。但是风险是时刻变化的、风险是不能确定的，你不可能提前预期所有的  风险，你得学会“以动制动”，动态地、持续地应用RBT技术。哪怕如此，你仍然无法避免所有的风险，仍然会有“黑天鹅  ”发生，因为软件测试的过程充满了随机性。</p>
<p>ReqBT（基于需求的测试）是个至少从数学上说很严谨的测试技术，它  会用因果图的方法把业务中的每一个原子逻辑规则都表达出来。ReqBT的创始人Richard Bender认为只要使用了ReqBT方法，  不会遗漏一个从黑盒角度讲、功能上的、业务逻辑相关的、严重的bug。我深知这套方法的妙处，但仍然对如上的陈述有所  怀疑，原因无他，测试中的不确定性太多，没有哪个确定性的理论是银弹，可以保证没有某类的“黑天鹅”发生。</p>
<p>但这并不表示这些形式或模式确定类的技术没有任何用处、只要使用不确定性的技术比如ET（探索性测试）、RST（快速软  件测试）等就好了。应该说，这些确定性的方法（RBT、ReqBT等）和不确定性的方法（ET、RST等）结合起来使用的话，“  动静结合”，会更有效地减少测试中“黑天鹅”的发生。</p>
<p>3. 判断是否是“黑天鹅”</p>
<p>想知道哪些重要的软件  缺陷是“黑天鹅”，哪些不是？只要问一问，这些bug与出现之前所预期的相比较，是否是在预料之中的？</p>
<p>我们会发  现，这些重要的bug大体可以分为两类：一类是可以预期发生的，但是并没有采取及时的措施去规避；一类是不被预期发生  的，认为不应该发生这种缺陷。这就启发我们在做RCA（缺陷根因分析）时，对不同类bug的分析会带来不同的收获。</p>
<p>分析可以预期发生的严重缺陷，可以很好地帮助我们改进已经在实施的确定类方法或技术中的不足。比如在实施RBT  过程中，为什么没有识别出某个风险？或者为什么对风险级别的估计不足？或者为什么没有对已知的风险采取风险规避措施  ？再比如在应用MBT（基于模型的测试技术）过程中，为什么某一个因子在建模时被遗漏了？或者为什么基于模型生成测试  条件或测试用例时某个重要的参数被忽略掉了？再比如按照企业既定的流程管理软件测试的过程中，为什么在测试策略或测  试方案中忽略了这一风险？或者为什么在测试分析和测试设计中没有覆盖这个风险点？或者为什么在测试执行环节没有发现  这个缺陷？等等。通过这样的RCA过程，可以更好地帮助我们改善既有的测试方法或流程。</p>
<p>分析不被预期发生的严重  缺陷，可以为我们开展不确定类测试方法或技术提供更多的输入和想法。例如本文开篇所举的那个关于某算法失效的例子，  想通过确定类的测试方法、正向的方式提前设计（也就是预期）相关的测试用例，基本不大可能。相反，我们换一个角度，  也许在ET中探索出这个缺陷的几率更大一些，比如适当增加与用户应用环境相关的各种因子组合的复杂场景测试的session  。</p>
<p>《黑天鹅》是一本关于不确定性的书。“有两种认识现象的方式。第一种排除不正常的现象，只关注正常现象。  研究者不理会意外事件，只研究正常案例。第二种方法则认为，为了理解这一现象，人们需要首先考虑极端现象，尤其是当  它们有非同寻常的效应累积的时候，比如黑天鹅现象。”对于测试而言，如果希望了解我们的不足，这两类缺陷（可以被预  期的缺陷和不可以被预期的缺陷）都要分析。</p>
<p>4. 我们所不知道的更有意义</p>
<p>“黑天鹅的逻辑是，你不知道的  事比你知道的事更有意义，因为许多黑天鹅事件正是由于它们不被预期而发生和加剧的。”作者认为现在的世界由不确定性  主导，不论这个结论正确与否，单就测试而言，这个结论是非常适用的，软件测试是由不确定性主导的。测试就是寻找未知  的过程，这些未知的事情包括未知的缺陷、未知的被测对象的质量状况、未知的真实的被测对象是什么样的以及所有那些你  认为你已经知道的但实际上是你不知道的软件相关的信息，这些未知给予测试挑战的同时也赋予测试很大的意义。</p>
<p>可以这样说，所有的测试用例都是基于测试人员已知的知识设计出来的，执行这些用例有机会发现那些能够被预期的缺陷；  而测试中的“黑天鹅”- 那些重要的不被预期的缺陷，有多少是由测试用例发现的？</p>
<p>分析每一只“黑天鹅”，会帮  助我们发现那些原本对于我们是“未知”的东西，每一只“黑天鹅”的遗漏，都是由于一些“未知”的因素，或者是未知的  知识或信息、或者是不知道某些信息的重要程度而加以重视。下一次测试中，就会有意识地尽量拓宽我们的已知领域，减少  “黑天鹅”发生的次数。</p>
<p>探索性测试在拓宽“已知领域”方面功不可没。当我们需要探索时、当我们不知道下一步  测试什么时、当我们想要获得更多的想法时，我们使用探索性测试，ET有助于拓宽我们的测试深度和测试宽度，尽可能扩大  已知领域的边界，缩小我们未知的领域。</p>
<p>5. 结论</p>
<p>你看到一个后果很严重的缺陷，正是由于你认为它不应该  发生？这是不是很奇怪？不管你采用什么样的测试方法、你的测试团队有多么强大、你在测试上投入了多少人力物力，测试  中的“黑天鹅”总会发生。</p>
<p>作者在《黑天鹅》书中指出人性的一个弱点：“习惯于学习精确的东西，而不是总体的  东西”，并且把“由于只关注那些纯粹而有明确定义的‘形式’而导致的错误”称为‘柏拉图化’”。测试的柏拉图化思想  会让你只关注外在的形式，例如测试的流程是否遵守、测试的模板是否应用、测试方法的具体步骤是否实施，而开始忽略其  他不那么具体不那么明确不那么美好和解释得清的事务，忽略那些显得有些混乱和不可琢磨的事务，比如在有些人眼里，探  索性测试不容易管理、不好解释给别人、步骤不那么明确、有太多不可琢磨的东西在里面。</p>
<p>就像敏捷里承认变化总  会存在而去拥抱变化一样，我们也应该正视测试中“黑天鹅”现象的存在，并尽最大可能地多尝试以减少“黑天鹅”发生的  机会（拓展已知领域、减少未知领域），并且一旦“黑天鹅”发生了尽最大可能地把握黑天鹅机会（分析那些未知点，更好  地应用不确定类的方法，寻求测试改进）。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:06:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e6%9e%90/" title="分析">分析</a>, <a href="https://www.iamivan.net/tag/%e7%8e%b0%e8%b1%a1/" title="现象">现象</a>, <a href="https://www.iamivan.net/tag/%e7%bc%ba%e9%99%b7/" title="缺陷">缺陷</a>, <a href="https://www.iamivan.net/tag/%e8%82%a1%e7%a5%a8%e9%a2%84%e6%b5%8b/" title="股票预测">股票预测</a>, <a href="https://www.iamivan.net/tag/%e6%9c%aa%e7%9f%a5%e7%b1%bb/" title="未知类">未知类</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>软件测试中的黑天鹅系列（一） 认识软件测试中的黑天鹅的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJPV5p.html" rel="bookmark">架构之坑系列1：重构中的过度设计与高可用银弹</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是一个坑系列,会说一些在系统设计.系统架构上的坑,这些都是我想到哪说到哪,有像这篇一样比较宏观的坑,后面的文章也会有到具体技术细节的(比如某个函数,某个系统调用)坑.总之,到处都是坑,这些坑有些是我经历过的,有些是听说的,你也可以留言说说你遇到的坑.   第一部分,我们从重构这个场景来看看系统架构的设计中过度设计这个坑.首先,我们这里说的重构,和&lt;重构:改善既有代码的设计&gt;这本书中的重构不太一样,这是本好书,他主要说的是代码级别的重构,这种重构是需要在编码的时候时时刻刻进行的,更多的是一种编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5v0mz.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;7&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第六篇:Flash游戏开发系列一:游戏中的敌人. 五.跟踪导弹(续完) 上次我们已经知道怎样让导弹的旋转看起来像那么回事,紧接着就是让导弹运动起来了. 导弹的一些属性,我们需要好好定义一下,这是完整的初始化函数: init = function () {enemy._x = 40;enemy._y = 350;enemy._rotation = 0;enemy_obj.MAXAngle = 6;enemy_obj.MAXSpeed = 4;enemy_obj.speedX = enemy_obj			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMg65Ab.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;6&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第五篇:Flash游戏开发系列一:游戏中的敌人. 五.跟踪导弹(续) 前面讲过了如何让导弹朝向玩家,但是真正在应用的时候,不可能这么生硬的体现.大家可能也发现了,导弹的方向一直指向玩家,其实很不真实,那么如何才能更加真实一些呢.常用的方法有几种,我们这里介绍其中一种,其它的大家可能要去参考游戏开发图书了. 在这里,我们使用的方法是,导弹有一个最大转向角度,也就是说,如果转向达到这个角度,就不能再转了,这样,看起来就会真实一些,导弹也就不回一下子面对玩家,看看下面这个例子,我把导弹的最大转向角度设			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvyOAb.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;5&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第四篇:Flash游戏开发系列一:游戏中的敌人. 五.跟踪导弹 看看这个例子,在动画屏幕上按下鼠标,导弹就会跟踪玩家,直到击中玩家: 对于新手来说,一下子就实现它可能不太容易,我们来一点一点的做. (1)导弹的方向 我们先来实现导弹朝向玩家的功能,就像下面这个:(按下鼠标观看) 首先,我们注意到,敌人的导弹是要朝向玩家的,这和前面不同.前面的敌人是一个圆头圆脑的家伙,不用分辨它的方向.我们就先来看一下如何让敌人有方向感. 首先给新手讲解一下基本知识:用鼠标来触发动画. 我们先设定一个变量,布尔类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpnqyrM.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;4&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第三篇:Flash游戏开发系列一:游戏中的敌人. 四(插).半随机移动的敌人 看看这个例子: 我们可以看到,一个敌人按照一定的规律从上面到下面移动.主要的规律是自上而下,但是移动的范围是随机的.这种方法在早期的游戏里面经常使用,包括一些大型的游戏.其实这是一种非常简单的运动方式,但是如果使用得当,也很有威胁. 我们大概瞧一下原理: 敌人每次向一个方向以随机的速度走八步,然后再改变方向,再走八步.在这个例子里面,为了简单说明,敌人走到画面底部以后,我们会让它重新回到原来的位置,重新再走. 我们创建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlwPYb.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;3&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第二篇:Flash游戏开发系列一:游戏中的敌人. 三.指定范围内的跟踪深化 再看看这个例子: 现在的敌人的视线范围比较真实了,它一直在四周查看,只有当你进入它的视觉范围的时候,敌人才会来追赶你. 这就是有指定范围的跟踪敌人,它的原理是和前面一样的: 如果(玩家进入敌人范围){ 如果(玩家x坐标 &lt;&gt; 敌人x坐标){调整敌人x坐标,趋近玩家x坐标}如果(玩家y坐标 &lt;&gt; 敌人y坐标){调整敌人y坐标,趋近玩家y坐标}} 我们可以在 enemy 里面放置一个扇形的范围,给一个实例名叫做			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeVAVb.html" rel="bookmark">Flash游戏开发系列一：游戏中的敌人&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一篇:Flash游戏开发系列一:游戏中的敌人 上一次,我们已经学习了最基本的敌人跟踪方法,这次,我们来限制一下敌人. 二.指定范围内的跟踪 首先看看这个例子: 现在的敌人周围有了一个范围,那么,只有当你进入这个范围的时候,敌人才会来追赶你. 这就是有指定范围的跟踪敌人,它的原理是: 如果(玩家进入敌人范围){  如果(玩家x坐标 &lt;&gt; 敌人x坐标){      调整敌人x坐标,趋近玩家x坐标  }  如果(玩家y坐标 &lt;&gt; 敌人y坐标){      调整敌人y坐标,趋近玩家y坐标			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQP1xQz.html" rel="bookmark">Photoshop通道应用系列1：通道中有些什么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通道的重要性就不用多说了,美国PS专家称:&quot;通道是核心,蒙板是灵魂&quot;,足以说明通道在Photoshop中的重要地位.早在几年前,就有朋友要求我讲一些通道基础知识及其应用技巧,由于工作忙一直也没有写,但总觉得欠了朋友的帐.虽说通道本身原理并不复杂,但适当地应用好通道则是一件很复杂也很灵活的事情. 还有一个重要原因是自己担心介绍不好或片面,既误人又害已,我也需要不断深入研究和多多实践,只有完全成熟的东西才敢往外发.通道及应用是从初级PS应用往高级PS应用的必经之路. 从现在起,我开始陆续介			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlBDZRz.html" rel="bookmark">IdeaCentre B5系列主机使用过程中经常死机怎么办</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  故障现象: IdeaCentre B5系列主机使用过程中经常死机. 解决方案: 1. 请您确认是否安装了新的硬件或是软件之后出现的,如果是,建议您卸载最新安装的软件和硬盘尝试故障是否排除. 2. 请您确认机器死机后关机是否可以立刻重新开机,还是需要等待一段时间才可以打开,如果无法直接开机,您需要参考下面的地址和电话进行维修,此问题是散热问题导致的. 3. 观察机器是否在运行某一个程序或是某一款游戏的时候出现死机,如果是,考虑重新安装此程序尝试,或是咨询软件开发商. 4. 如果您的问题都不在以			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2RDBb.html" rel="bookmark" class="title">Photoshop给人物照片调出柔和的淡调黄紫色</a>
					<div>
						淡黄色图片比较好把握,调色的时候可以用曲线等调出蓝黄色主色,主色不要太浓,然后根据需要把蓝色转为其它颜色.后期再增加一些高光及暗部等即可. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开照片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOgGRM.html" rel="bookmark" class="title">solaris的sar命令&lpar;一&rpar; 如何检查文件访问</a>
					<div>
						sar是Solaris下重要的性能检测命令,熟悉这个命令可以及时地检测系统个方面的性能,对系统管理很有帮助. 使用 sar 命令可执行以下任务: 组织并查看有关系统活动的数据. 根据特殊请求访问系统活 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN1g8b.html" rel="bookmark" class="title">使用DELPHI实现文本文件显示和声音同步</a>
					<div>
						在一些语言教学软件中,经常使用文本显示和声音同步播放,我们可以用DELPHI实现之. 一.材料的制作 首先,我们选择几篇文章,这里我们选择马丁路德金.林肯和里根的演说,每一篇文章分为若干句,在制作声音 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDABwrb.html" rel="bookmark" class="title">ppt2007怎么插入表格？</a>
					<div>
						  ppt2007怎么插入表格?           可以先选中&quot;插入&quot;菜单,然后单击&quot;表格图标&quot;,PowerPoint2007会显示&quot;表格&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdE5OM.html" rel="bookmark" class="title">把Excel 2013表格按照单元格颜色进行排序</a>
					<div>
						  ①打开下面的表格,要将金额列单元格按照红黄绿的顺序进行排序,首先选中整个区域,单击菜单栏--数据--排序. ②弹出排序对话框,主要关键字选为金额,排序依据单元格颜色,次序红色,然后单击添加条件按钮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK0ZNM.html" rel="bookmark" class="title">清华同方电脑主板BIOS清除密码</a>
					<div>
						你肯定还不知道清华同方的bios默认的密码吧.bios通用密码有六位和八位,六位是thtfpc,八位是00000000. 那么清华同方电脑主板BIOS清除密码? 在电脑断电的情况下,首先打开主机箱,然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKxLaM.html" rel="bookmark" class="title">百度杀毒和百度卫士怎么卸载？</a>
					<div>
						  这里整理了下我遇到的几种卸载或删除不了的现象: 1.安装目录文件夹删除不了,提示需要administrators权限,用管理员权限也删除不了.如下图: 2.管家启动项里百度杀毒.百度卫士相关服务无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7GE9M.html" rel="bookmark" class="title">qt5-x64的系统上为什么QT 5&period;4&period;1可以打开32位的sqlite3 但是不能进行插入读出操作&quest;</a>
					<div>
						问题描述 x64的系统上为什么QT 5.4.1可以打开32位的sqlite3 但是不能进行插入读出操作? 我用的是Qt 5.4.1 for Windows 32-bit (MinGW 4.9.1, 8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjm4E0z.html" rel="bookmark" class="title">PostgreSQL 9&period;5&period;0 PK Oracle 12&period;0&period;1&period;2&period;0 TPC-C性能极限</a>
					<div>
						Oracle 12c TPC-C 测试请参考: http://blog.163.com/digoal@126/blog/static/1638770402015112344924835/ 文件系统为X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxWvmb.html" rel="bookmark" class="title">12日讲座：个人网站如何选择适合自己的赚钱方式</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 今天我给大家要讲的内容主要有以下几个要点:1.目前的大概的互联网形势.2.目前国内网站的种类和构成.3.目前网站的主要收入模式.4.个人网站如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZR4Nb.html" rel="bookmark" class="title">什么是需求分析</a>
					<div>
						一.需求的概念 1.需求是什么? 简单的说,每当你想到,如果可以这样来做什么就好了,那就是一个需求. 一个很形象的例子,饿了,想吃饭.这就是一个需求. 2.需求分析是什么? 理解什么是需求之后,那么需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1ldL5b.html" rel="bookmark" class="title">网络子系统30&lowbar;桥接子系统通用接口</a>
					<div>
						// 添加网桥设备 // 参数: // name,需要全局唯一 // 调用路径:socket ioctl-&gt;br_add_bridge // 函数主要任务: // 1.创建一个新的网络设备 // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Qvd0p.html" rel="bookmark" class="title">横竖屏 切换-Android横竖屏切换有什么差别呢？</a>
					<div>
						问题描述 Android横竖屏切换有什么差别呢? 个人感觉Android的横竖屏切换是因为重力的感应,之后软件的布局会改变, 但是横竖屏切换的具体差别是什么? 解决方案 页面:页面会重新加载,只要你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQPV5z.html" rel="bookmark" class="title">我的程序哪里错了？-shell中程序调试问题 不知道哪错了 求解答</a>
					<div>
						问题描述 shell中程序调试问题 不知道哪错了 求解答 #!/bin/bashfunction a {read -p &quot;&quot;input: &quot;&quot; valueech ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kr1PM.html" rel="bookmark" class="title">图片-C&num;窗体Form1中实现曲线绘制</a>
					<div>
						问题描述 C#窗体Form1中实现曲线绘制 刚接触C#,想实现在C#中绘制曲线.Form1中有两个按钮一个panel,分别是x-y数据导入 按钮,绘制图形按钮和曲线显示框,并显示出做坐标名称x,y,单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZABmz.html" rel="bookmark" class="title">求各位帮帮忙-C语言指针问题&comma;求高手解惑</a>
					<div>
						问题描述 C语言指针问题,求高手解惑 #include void fun(double *sn, int n); int main(void) { int n; double Sum; printf( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rE5op.html" rel="bookmark" class="title">视频-请问从哪里能找到s5pv210 fimc 的 API 函数？</a>
					<div>
						问题描述 请问从哪里能找到s5pv210 fimc 的 API 函数? 最近研究在s5pv210上面处理视频,苦于找不到调用 fimc 的API函数,希望各位大神施以援手!!!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgGQBb.html" rel="bookmark" class="title">【C&sol;C&plus;&plus;学院】0830-兰不达表达式&sol;STL算法-操作数据</a>
					<div>
						兰不达表达式 #include&lt;iostream&gt; #include&lt;vector&gt; #include&lt;algorithm&gt;//算法 lambda表达式,不仅仅适用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyl54z.html" rel="bookmark" class="title">深圳江波龙发布国内首款3D TLC固态盘：自主固件 9月量产</a>
					<div>
						3D NAND已经是现今SSD的中坚力量,其容量.速度.寿命.价格较此前2D款都有提升.据官网消息,深圳江波龙(Longsys)昨日正式发布3D TLC SSD新品S409,这是国内首款基于3D TL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xq1kb.html" rel="bookmark" class="title">9月中国域名服务商Top25：万网份额22&period;69&percnt;居首</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 中国IDC评述网10月10日报道: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk1ZDM.html" rel="bookmark" class="title">共同成立首个探索年轻人消费市场的营销联盟</a>
					<div>
						根据我国第六次人口普查结果,我国16至26岁的年轻人口占全国总人口的17%,达2.25亿.陈一舟表示,我国年轻人按绝对人数已一跃成为世界上的&quot;第五大国&quot;,伴随教育程度和城镇化比例额 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNVZ3M.html" rel="bookmark" class="title">《Android 应用案例开发大全（第3版）》&mdash;&mdash;第1&period;1节Android的来龙去脉</a>
					<div>
						第1章 初识庐山真面目--Android简介 Android 应用案例开发大全(第3版) Android一词的本义指&quot;机器人&quot;,同时也是Google于宣布的基于Linux平台的开源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ1akp.html" rel="bookmark" class="title">如何实现hadoop集群间通信和作业调度？</a>
					<div>
						问题描述 有多个hadoop集群,各集群的hadoop版本一致,这几个hadoop集群可能分布在不同地域.1.要求能在其中一个集群的管理端看到其他集群的节点信息,比如hdfs的文件目录信息等.2.要求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV775lb.html" rel="bookmark" class="title">php版微信公众平台入门教程之开发者认证的方法&lowbar;php实例</a>
					<div>
						本文讲述了php版微信公众平台开发者认证的方法.分享给大家供大家参考,具体如下: 微信公众平台如何成为开发者? 登录微信公众平台后,点击高级功能=&gt;开发模式=&gt;成为开发者=&gt;填写接口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N8Vjp.html" rel="bookmark" class="title">网站交叉链接好处与心得</a>
					<div>
						1.为何要做交叉链接 情况1.优化重点网站或频道 你有A网站和B网站都是老站,PR值也都不低.但是B网站对你来说,更有商业价值,如果能把优化做得更好,你能赚更多的钱.但是光通过B网站去外面交换友情链接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze08JNp.html" rel="bookmark" class="title">android Fragments详解七&colon;fragement示例</a>
					<div>
						下例中实验了上面所讲的所有内容.此例有一个activity,其含有两个fragment.一个显示莎士比亚剧的播放曲目,另一个显示选中曲目的摘要.此例还演示了如何跟据屏幕大小配置fragment. 主a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWYGqM.html" rel="bookmark" class="title">迪信通智能手机节开幕 精彩会员活动启动</a>
					<div>
						席卷全国的迪信通&quot;智能手机节&quot;超级优惠盛典自10月15日开幕以来受到广大消费者的一致好评.活动一经推出,众多消费者纷纷涌入迪信通各大门店下单抢购智能机,作为国内最大的专业手机连锁卖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZmmvqp.html" rel="bookmark" class="title">红娘网7651诚信宣言</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 导语 通过网络婚介来寻找伴侣已是不少网友的选择,但是由于婚恋网站良莠不齐,网恋被骗财骗色的负面报道时常见诸报端.如何提升&quot;网络红娘&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeR2Vp.html" rel="bookmark" class="title">聊天机器人并不适合每一项业务和每个人</a>
					<div>
						7月6日消息,据国外媒体报道,Uber开发者平台负责人克里斯·梅西纳(Chris Messina)曾称2016年是对话式商务元年.当用户手机屏幕上的应用图标日趋饱和,而交互式接口正在准备替代用户在互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWYVxz.html" rel="bookmark" class="title">宜搜汪溪：宜搜在移动搜索领域已经占据了超过40％的市场份额</a>
					<div>
						和讯网消息 3月25日,2012中国(深圳)IT领袖峰会于3月24-25日在深圳五洲宾馆举行,本届峰会主题为&quot;转型中的谋略之道&quot;.作为本届峰会的全程战略合作伙伴,和讯网将对大会进行 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
